<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import ErrorAlert from "@/components/item/ErrorAlert.vue";
import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading },
  name: 'SignUp',
  props: {
  },
  setup() {
    const data = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
            name : '',
            email : '',
            username : '',
            password : {
               confirm: '',
               password: ''
            },
            agree : false
         });
    const rules = computed(() => {
         return {
            name : { required },
            email : { required, email },
            username : { required },
            password : { 
               password : {required },
               confirm : { required, sameAs : sameAs( state.password.password ) }
            },
            agree : { sameAs : sameAs ( true ) }
         }
    });
    const v$ = useValidate(rules, state)
    async function saveData() {
      loading.value = true;
      const requestData = {
         name : state.name,
         email : state.email,
         username : state.username,
         password : state.password.password,
      }
      const result = await HTTP.post(`register`, JSON.stringify( requestData )).then(response => {
            data.value = response.data.message
            setTimeout(() => {
               this.doSignIn()
            },1500);
         })
         .catch(e => {
            const jsonError = e.toJSON();
            error.value = jsonError.message
         })
      loading.value = false;
    }

    return {
      data,
      loading,
      error,
      state,
      v$,
      saveData
    };
  },methods: {
    submitForm() {
      this.v$.$validate()
      if(!this.v$.$error){
         this.saveData()
      }
    },
    doSignIn() {
      localStorage.signup = !store.state.signup
      store.commit('togleSignUp')
      location.reload()
   }
  }
}
</script>
<template> 
  <Loading v-if="loading" />
  <div class="wrapper" v-if="!loading">
    <section class="login-content">
      <b-form  @submit="submitForm">
         <div class="container">
            <div class="row align-items-center justify-content-center height-self-center">
               <div class="col-lg-8">
                  <div class="card auth-card">
                     <div class="card-body p-0">
                        <div class="d-flex align-items-center auth-content">
                           <div class="col-lg-7 align-self-center">
                              <div class="p-3">
                                 <h2 class="mb-2">Sign Up</h2>
                                 <p>Create your account.</p>
                                    <div class="row">
                                       <div class="col-lg-12">
                                          <!-- <ErrorAlert :validation="v$" v-if="v$.$error" /> -->
                                          <div class="alert bg-white alert-danger" role="alert" v-if="v$.$error || error" >
                                             <div class="iq-alert-icon">
                                                <i class="ri-information-line"></i>
                                             </div>
                                             <div class="iq-alert-text">
                                                <!-- <span v-for="errorMessage in reconstructValidation">{{errorMessage}}<br /></span> -->
                                                <span v-if="v$.name.$error"> Field Full Name {{v$.name.$errors[0].$message}}<br /></span>
                                                <span v-if="v$.username.$error"> Field Username {{v$.username.$errors[0].$message}}<br /></span>
                                                <span v-if="v$.email.$error"> Field Email {{v$.email.$errors[0].$message}}<br /></span>
                                                <span v-if="v$.password.password.$error"> Field Password {{v$.password.password.$errors[0].$message}}<br /></span>
                                                <span v-if="v$.password.confirm.$error"> Field Confirm Password {{v$.password.confirm.$errors[0].$message}}<br /></span>
                                                <span v-if="v$.agree.$error"> You must agree with our terms of use<br /></span>
                                                <span v-if="error"> {{error}}</span>
                                             </div>
                                          </div>
                                          <div class="alert bg-white alert-secondary" role="alert" v-if="data">
                                             <div class="iq-alert-text">{{data}}</div>
                                          </div>
                                       </div>
                                       <div class="col-lg-6">
                                          <div class="floating-label form-group">
                                             <input v-model="state.name" class="floating-input form-control" :class="{'is-invalid' : v$.name.$error }" type="text" placeholder=" " >
                                             <label>Full Name </label>
                                          </div>
                                       </div>
                                       <div class="col-lg-6">
                                          <div class="floating-label form-group">
                                             <input v-model="state.username" class="floating-input form-control" :class="{'is-invalid' : v$.username.$error }" type="text" placeholder=" ">
                                             <label>Username</label>
                                          </div>
                                       </div>
                                       <div class="col-lg-6">
                                          <div class="floating-label form-group">
                                             <input v-model="state.password.password" class="floating-input form-control" :class="{'is-invalid' : v$.password.password.$error }" type="password" placeholder=" ">
                                             <label>Password</label>
                                          </div>
                                       </div>
                                       <div class="col-lg-6">
                                          <div class="floating-label form-group">
                                             <input v-model="state.password.confirm" class="floating-input form-control" :class="{'is-invalid' : v$.password.confirm.$error }" type="password" placeholder=" ">
                                             <label>Confirm Password</label>
                                          </div>
                                       </div>
                                       <div class="col-lg-6">
                                          <div class="floating-label form-group">
                                             <input v-model="state.email" class="floating-input form-control" :class="{'is-invalid' : v$.email.$error }" type="email" placeholder=" ">
                                             <label>Email</label>
                                          </div>
                                       </div>
                                       <div class="col-lg-12">
                                          <div class="custom-control custom-checkbox mb-3">
                                             <input v-model="state.agree" type="checkbox" class="custom-control-input" id="customCheck1">
                                             <label class="custom-control-label" for="customCheck1">I agree with the terms of use</label>
                                          </div>
                                       </div>
                                    </div>
                                    <button type="submit" class="btn btn-primary" @click="submitForm" >Sign Up</button>
                                    <p class="mt-3">
                                       Already have an Account <a href="#sign-in" class="text-primary" @click="doSignIn" >Sign In</a>
                                    </p>
                              </div>
                           </div>
                           <div class="col-lg-5 content-right">
                              <img src="../assets/images/login/01.png" class="img-fluid image-right" alt="">
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
      </b-form>
    </section>
  </div>
</template>

<style scoped>
</style>
